﻿using System;
using System.Collections.Generic;
using System.Text;
using System.Data.OleDb;
using System.Data.Common;

namespace ZhCun.Framework.DataAccess.DbHelper
{
    public class OleDbHelper : DbHelperBase
    {
        public OleDbHelper(string connStr)
            : base(connStr)
        { }

        OleDbConnection _DBConnectionObj;
        OleDbCommand _DbCommandObj;
        OleDbDataAdapter _DbDataAdapterObj;

        protected override DbConnection DBConnectionObj
        {
            get
            {
                //SqlBulkCopy aa = new SqlBulkCopy(new SqlConnection());
                if (_DBConnectionObj == null)
                {
                    _DBConnectionObj = new OleDbConnection(_ConnStr);
                }
                return _DBConnectionObj;
            }
        }

        protected override DbCommand DbCommandObj
        {
            get
            {
                if (_DbCommandObj == null)
                {
                    _DbCommandObj = new OleDbCommand();
                }
                return _DbCommandObj;
            }
        }

        protected override DbDataAdapter DbDataAdapterObj
        {
            get
            {
                if (_DbDataAdapterObj == null)
                {
                    _DbDataAdapterObj = new OleDbDataAdapter();
                }
                return _DbDataAdapterObj;
            }
        }
    }
}
