﻿using System;
using System.Collections.Generic;
using System.Text;
using System.Data.OracleClient;
using System.Data.Common;

namespace ZhCun.Framework.DataAccess.DbHelper
{
    public class OracleHelper : DbHelperBase
    {
        public OracleHelper(string connStr)
            : base(connStr)
        { 
             
        }
        
        OracleConnection _DBConnectionObj;
        OracleCommand _DbCommandObj;
        OracleDataAdapter _DbDataAdapterObj;
 
        protected override DbConnection DBConnectionObj
        {
            get
            {
                //SqlBulkCopy aa = new SqlBulkCopy(new SqlConnection());
                if (_DBConnectionObj == null)
                {
                    _DBConnectionObj = new OracleConnection(_ConnStr);
                }
                return _DBConnectionObj;
            }
        }

        protected override DbCommand DbCommandObj
        {
            get
            {
                if (_DbCommandObj == null)
                {
                    _DbCommandObj = new OracleCommand();
                }
                return _DbCommandObj;
            }
        }

        protected override DbDataAdapter DbDataAdapterObj
        {
            get
            {
                if (_DbDataAdapterObj == null)
                {
                    _DbDataAdapterObj = new OracleDataAdapter();
                }
                return _DbDataAdapterObj;
            }
        }
    }
}
